package com.ruoyi.scientific.service;

import com.ruoyi.scientific.domain.ProjectApplication;
import com.ruoyi.scientific.domain.vo.ProjectApplicationVo;
import com.ruoyi.scientific.domain.bo.ProjectApplicationBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 项目申报Service接口
 *
 * @author zhanli
 * @date 2024-07-18
 */
public interface IProjectApplicationService {

    /**
     * 查询项目申报
     */
    ProjectApplicationVo queryById(Long projectId);

    /**
     * 查询项目申报列表
     */
    TableDataInfo<ProjectApplicationVo> queryPageList(ProjectApplicationBo bo, PageQuery pageQuery);

    /**
     * 查询项目申报列表
     */
    List<ProjectApplicationVo> queryList(ProjectApplicationBo bo);

    /**
     * 新增项目申报
     */
    Boolean insertByBo(ProjectApplicationBo bo);

    /**
     * 修改项目申报
     */
    Boolean updateByBo(ProjectApplicationBo bo);

    /**
     * 修改项目预算审批流程
     */
    Boolean updateBudgetProc(ProjectApplicationBo bo);

    /**
     * 校验并批量删除项目申报信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 更新项目Id更新预算信息
     */
    Boolean updateBudgetInfoById(Long projectId, Long newProjectBudget);
}
